#include "Watcher.h"
#include <Directory.h>
#include <Entry.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

FILE *prefs;

void Watcher::LoadFiles()
{
  //declare local space for this stuff.
  char mimename[B_MIME_TYPE_LENGTH];
  char openname[B_FILE_NAME_LENGTH];
  char closename[B_FILE_NAME_LENGTH];
  int32 total;
  
  printf("Loading important data files:\n");

  //open the file.
  prefs = fopen("/boot/home/config/settings/WatcherPrefs","r");
  
  //get the number of data entries as marked in the header.
  fscanf(prefs,"%i", &total);
  lst_Subjects = (Subject **) malloc(sizeof(Subject *) * total);
  subjects = total;
  printf ("setting subjects to: %i \n", subjects);
  
  BDirectory scriptdir("/boot/home/config/settings/Watcherscripts");
  BEntry openfile;  entry_ref openref;
  BEntry closefile; entry_ref closeref;
  
  for (int32 index = 0; index < total; index++)
  {
    //first upload all the information from the file.
    fscanf(prefs,"%s",mimename);
    fscanf(prefs,"%s",openname);
    fscanf(prefs,"%s",closename);
      
    //allocate space for local copies.
    lst_Subjects[index] = new Subject();
    
    lst_Subjects[index]->mimesignature = (char *) malloc(strlen(mimename));
    lst_Subjects[index]->openscriptfile = new (entry_ref);
    lst_Subjects[index]->closescriptfile = new (entry_ref);
    
    //set up the file stuff.
    status_t errorcode;

    errorcode = openfile.SetTo(&scriptdir, openname, true);
    if (errorcode)
    {
      printf("Error in finding open script: %s \n", strerror(errorcode));
      break;
    } 

    errorcode = closefile.SetTo(&scriptdir, closename, true);
    if (errorcode)
    {
      printf("Error in finding close script: %s \n", strerror(errorcode));
      break;
    } 
    
    printf("copying information to internal store.\n");
    
    //copy from the temporary information slots to the new information slots.
    strcpy(lst_Subjects[index]->mimesignature, mimename);
    
    openfile.GetRef(lst_Subjects[index]->openscriptfile);
    closefile.GetRef(lst_Subjects[index]->closescriptfile);
    
    printf("Application mimetype:(%s) loaded for openscript:(%s) and closescript:(%s) \n"
     ,mimename, openname, closename);
  };
  
  //close the file.
  fclose(prefs);  
};