#include "Watcher.h"
#include <stdio.h>
#include <string.h>

Watcher::Watcher()
  :BApplication("application/x-vnd.Yonemoto.Watcher")
{
  new BRoster();
  be_roster->StartWatching(be_app_messenger);
  LoadFiles();
};

Watcher::~Watcher()
{
};

void Watcher::MessageReceived(BMessage *msg_Received)
{
  Subject * target = NULL;
  const char *mimetype;
  //this function is the core of the entire program.
  switch(msg_Received->what)
  {
    case B_SOME_APP_LAUNCHED:
      printf("an application was opened.\n");
      //search through the list of subjects to find if it's one to look for..
      msg_Received->FindString("be:signature", &mimetype);
      
      target = CheckType(mimetype);
      
      if (target)					//the Target has been found.
        target->OpenRun();			//so execute the opening application.
    break;
    case B_SOME_APP_QUIT:
      printf("an application was closed.\n");
      //search through the list of subjects to find out if it's one that died..
      msg_Received->FindString("be:signature", &mimetype);
      target = CheckType(mimetype);
      
      if (target)					//the Target has been found.
        target->CloseRun();			//so execute the closing application.
    break;
    default:
      BApplication::MessageReceived(msg_Received);
  };
};

Subject *Watcher::CheckType(const char * mimetype)
{
  for (int32 index = 0; index < subjects; index++)
  {
    if (mimetype)
      if (strcmp(mimetype, lst_Subjects[index]->mimesignature) == 0)
        return lst_Subjects[index];
  };
  
  return NULL;
};